
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 4.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : No
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _duration=R4
	.DEF _fr=R6

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G102:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G102:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x3:
	.DB  0x0,0x9,0x3D
_0x4:
	.DB  0x44,0x32,0x28,0x31,0x2F,0x34,0x29,0x20
	.DB  0x50,0x28,0x31,0x2F,0x38,0x29,0x20,0x45
	.DB  0x32,0x28,0x31,0x2F,0x38,0x29,0x20,0x46
	.DB  0x32,0x28,0x31,0x2F,0x34,0x29,0x20,0x50
	.DB  0x28,0x31,0x2F,0x38,0x29,0x20,0x44,0x32
	.DB  0x28,0x31,0x2F,0x38,0x29,0x20,0x46,0x32
	.DB  0x28,0x31,0x2F,0x38,0x29,0x20,0x46,0x32
	.DB  0x28,0x31,0x2F,0x38,0x29,0x20,0x45,0x32
	.DB  0x28,0x31,0x2F,0x38,0x29,0x20,0x44,0x32
	.DB  0x28,0x31,0x2F,0x38,0x29,0x20,0x45,0x32
	.DB  0x28,0x31,0x2F,0x34,0x29,0x20,0x41,0x31
	.DB  0x28,0x31,0x2F,0x34,0x29,0x20,0x45,0x32
	.DB  0x28,0x31,0x2F,0x34,0x29,0x20,0x50,0x28
	.DB  0x31,0x2F,0x38,0x29,0x20,0x46,0x32,0x28
	.DB  0x31,0x2F,0x38,0x29,0x20,0x47,0x32,0x28
	.DB  0x31,0x2F,0x34,0x29,0x20,0x50,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x45,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x47,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x47,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x46,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x45,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x44,0x32,0x28,0x31
	.DB  0x2F,0x34,0x29,0x20,0x50,0x28,0x31,0x2F
	.DB  0x34,0x29,0x20,0x41,0x32,0x28,0x31,0x2F
	.DB  0x34,0x29,0x20,0x44,0x33,0x28,0x31,0x2F
	.DB  0x34,0x29,0x20,0x43,0x33,0x28,0x31,0x2F
	.DB  0x34,0x29
_0x5:
	.DB  0x44,0x33,0x28,0x31,0x2F,0x38,0x29,0x20
	.DB  0x43,0x33,0x28,0x31,0x2F,0x38,0x29,0x20
	.DB  0x41,0x69,0x73,0x32,0x28,0x31,0x2F,0x38
	.DB  0x29,0x20,0x41,0x69,0x73,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x41,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x47,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x41,0x32,0x28,0x31
	.DB  0x2F,0x34,0x29,0x20,0x44,0x32,0x28,0x31
	.DB  0x2F,0x34,0x29,0x20,0x50,0x28,0x31,0x2F
	.DB  0x38,0x29,0x20,0x41,0x69,0x73,0x32,0x28
	.DB  0x31,0x2F,0x34,0x29,0x20,0x47,0x32,0x28
	.DB  0x31,0x2F,0x38,0x29,0x20,0x41,0x32,0x28
	.DB  0x31,0x2F,0x34,0x29,0x20,0x50,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x46,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x47,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x47,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x46,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x45,0x32,0x28,0x31
	.DB  0x2F,0x38,0x29,0x20,0x44,0x32,0x28,0x31
	.DB  0x2F,0x32,0x29
_0x6:
	.DB  0x47,0x32,0x28,0x31,0x2F,0x31,0x36,0x29
	.DB  0x20,0x46,0x32,0x28,0x31,0x2F,0x38,0x29
	.DB  0x20,0x44,0x32,0x28,0x31,0x2F,0x31,0x36
	.DB  0x29,0x20,0x45,0x32,0x28,0x31,0x2F,0x31
	.DB  0x36,0x29,0x20,0x46,0x32,0x28,0x31,0x2F
	.DB  0x38,0x29,0x20,0x44,0x32,0x28,0x31,0x2F
	.DB  0x31,0x36,0x29,0x20,0x45,0x32,0x28,0x31
	.DB  0x2F,0x31,0x36,0x29,0x20,0x46,0x32,0x28
	.DB  0x31,0x2F,0x38,0x29,0x20,0x45,0x32,0x28
	.DB  0x31,0x2F,0x31,0x36,0x29,0x20,0x44,0x32
	.DB  0x28,0x31,0x2F,0x31,0x36,0x29,0x20,0x43
	.DB  0x32,0x28,0x31,0x2F,0x38,0x29,0x20,0x47
	.DB  0x32,0x28,0x31,0x2F,0x31,0x36,0x29,0x20
	.DB  0x47,0x32,0x28,0x31,0x2F,0x31,0x36,0x29
	.DB  0x20,0x46,0x32,0x28,0x31,0x2F,0x31,0x36
	.DB  0x29,0x20,0x46,0x32,0x28,0x31,0x2F,0x31
	.DB  0x36,0x29,0x20,0x44,0x32,0x28,0x31,0x2F
	.DB  0x31,0x36,0x29,0x20,0x45,0x32,0x28,0x31
	.DB  0x2F,0x31,0x36,0x29,0x20,0x46,0x32,0x28
	.DB  0x31,0x2F,0x38,0x29,0x20,0x44,0x32,0x28
	.DB  0x31,0x2F,0x31,0x36,0x29,0x20,0x45,0x32
	.DB  0x28,0x31,0x2F,0x31,0x36,0x29,0x20,0x46
	.DB  0x32,0x28,0x31,0x2F,0x38,0x29,0x20,0x45
	.DB  0x32,0x28,0x31,0x2F,0x31,0x36,0x29,0x20
	.DB  0x44,0x32,0x28,0x31,0x2F,0x31,0x36,0x29
	.DB  0x20,0x43,0x32,0x28,0x31,0x2F,0x38,0x29

__GLOBAL_INI_TBL:
	.DW  0x03
	.DW  _freq
	.DW  _0x3*2

	.DW  0xD2
	.DW  _mel1
	.DW  _0x4*2

	.DW  0x9B
	.DW  _mel2
	.DW  _0x5*2

	.DW  0xD0
	.DW  _mel3
	.DW  _0x6*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <string.h>
;#include <ctype.h>
;#include <stdio.h>
;
;int duration;
;int fr;
;long int freq=4000000;

	.DSEG
;
;#define CLK_FREQ freq    // 
;#define PR 1                //  
;#define NOTE_DURATION duration  //   
;#define SEMITONE 1.0594631  //       
;#define START_NOTE 16.352   //   (  0- )
;#define OCTAVE_OFFSET 3     //  
;
;#define FOSC 4000000 // Clock Speed
;#define BAUD 9600
;#define MYUBRR (FOSC/16/BAUD-1)
;
;eeprom int registor;
;eeprom int track;
;
;char mel1[]={"D2(1/4) P(1/8) E2(1/8) F2(1/4) P(1/8) D2(1/8) F2(1/8) F2(1/8) E2(1/8) D2(1/8) E2(1/4) A1(1/4) E2(1/4) P(1/8) F2(1/8) G2(1/4) P(1/8) E2(1/8) G2(1/8) G2(1/8) F2(1/8) E2(1/8) D2(1/4) P(1/4) A2(1/4) D3(1/4) C3(1/4)"};
;char mel2[]={"D3(1/8) C3(1/8) Ais2(1/8) Ais2(1/8) A2(1/8) G2(1/8) A2(1/4) D2(1/4) P(1/8) Ais2(1/4) G2(1/8) A2(1/4) P(1/8) F2(1/8) G2(1/8) G2(1/8) F2(1/8) E2(1/8) D2(1/2)"};
;char mel3[]={"G2(1/16) F2(1/8) D2(1/16) E2(1/16) F2(1/8) D2(1/16) E2(1/16) F2(1/8) E2(1/16) D2(1/16) C2(1/8) G2(1/16) G2(1/16) F2(1/16) F2(1/16) D2(1/16) E2(1/16) F2(1/8) D2(1/16) E2(1/16) F2(1/8) E2(1/16) D2(1/16) C2(1/8)"};
;
;void Dig_init(int num) //       - OK
; 0000 001E {

	.CSEG
_Dig_init:
; 0000 001F  switch(num)
;	num -> Y+0
	RCALL SUBOPT_0x0
; 0000 0020   {
; 0000 0021   case 0:{PORTD=0b11000000; break;} //0
	SBIW R30,0
	BRNE _0xA
	LDI  R30,LOW(192)
	RJMP _0x80
; 0000 0022   case 1:{PORTD=0b11111001; break;} //1
_0xA:
	RCALL SUBOPT_0x1
	BRNE _0xB
	LDI  R30,LOW(249)
	RJMP _0x80
; 0000 0023   case 2:{PORTD=0b10100100; break;} //2
_0xB:
	RCALL SUBOPT_0x2
	BRNE _0xC
	LDI  R30,LOW(164)
	RJMP _0x80
; 0000 0024   case 3:{PORTD=0b10110000; break;} //3
_0xC:
	RCALL SUBOPT_0x3
	BRNE _0xD
	LDI  R30,LOW(176)
	RJMP _0x80
; 0000 0025   case 4:{PORTD=0b10011001; break;} //4
_0xD:
	RCALL SUBOPT_0x4
	BRNE _0xE
	LDI  R30,LOW(153)
	RJMP _0x80
; 0000 0026   case 5:{PORTD=0b10010010; break;} //5
_0xE:
	RCALL SUBOPT_0x5
	BRNE _0xF
	LDI  R30,LOW(146)
	RJMP _0x80
; 0000 0027   case 6:{PORTD=0b10000010; break;} //6
_0xF:
	RCALL SUBOPT_0x6
	BRNE _0x10
	LDI  R30,LOW(130)
	RJMP _0x80
; 0000 0028   case 7:{PORTD=0b11111000; break;} //7
_0x10:
	RCALL SUBOPT_0x7
	BRNE _0x11
	LDI  R30,LOW(248)
	RJMP _0x80
; 0000 0029   case 8:{PORTD=0b10000000; break;} //8
_0x11:
	RCALL SUBOPT_0x8
	BRNE _0x12
	LDI  R30,LOW(128)
	RJMP _0x80
; 0000 002A   case 9:{PORTD=0b10010000; break;} //9
_0x12:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x9
	LDI  R30,LOW(144)
_0x80:
	OUT  0x12,R30
; 0000 002B   }
_0x9:
; 0000 002C }
	RJMP _0x2060001
;
;//       12+1 
;unsigned char note_to_num (int note)
; 0000 0030   {
_note_to_num:
; 0000 0031     unsigned char nt=note & 0x07;
; 0000 0032     unsigned char temp=0;
; 0000 0033 
; 0000 0034     switch(nt)
	RCALL __SAVELOCR2
;	note -> Y+2
;	nt -> R17
;	temp -> R16
	LDD  R30,Y+2
	ANDI R30,LOW(0x7)
	MOV  R17,R30
	LDI  R16,0
	MOV  R30,R17
	RCALL SUBOPT_0x9
; 0000 0035       {
; 0000 0036         case 1: temp=1; break;
	RCALL SUBOPT_0x1
	BRNE _0x17
	LDI  R16,LOW(1)
	RJMP _0x16
; 0000 0037         case 2: temp=3; break;
_0x17:
	RCALL SUBOPT_0x2
	BRNE _0x18
	LDI  R16,LOW(3)
	RJMP _0x16
; 0000 0038         case 3: temp=5; break;
_0x18:
	RCALL SUBOPT_0x3
	BRNE _0x19
	LDI  R16,LOW(5)
	RJMP _0x16
; 0000 0039         case 4: temp=6; break;
_0x19:
	RCALL SUBOPT_0x4
	BRNE _0x1A
	LDI  R16,LOW(6)
	RJMP _0x16
; 0000 003A         case 5: temp=8; break;
_0x1A:
	RCALL SUBOPT_0x5
	BRNE _0x1B
	LDI  R16,LOW(8)
	RJMP _0x16
; 0000 003B         case 6: temp=10; break;
_0x1B:
	RCALL SUBOPT_0x6
	BRNE _0x1C
	LDI  R16,LOW(10)
	RJMP _0x16
; 0000 003C         case 7: temp=12; break;
_0x1C:
	RCALL SUBOPT_0x7
	BRNE _0x16
	LDI  R16,LOW(12)
; 0000 003D       }
_0x16:
; 0000 003E 
; 0000 003F     if ( (temp) && (note & 0x08) )
	CPI  R16,0
	BREQ _0x1F
	LDD  R30,Y+2
	ANDI R30,LOW(0x8)
	BRNE _0x20
_0x1F:
	RJMP _0x1E
_0x20:
; 0000 0040       temp++;
	SUBI R16,-1
; 0000 0041 
; 0000 0042     return (temp);
_0x1E:
	MOV  R30,R16
	RCALL __LOADLOCR2
	ADIW R28,4
	RET
; 0000 0043   }
;
;
;//    
;unsigned int note_to_freq (int note)
; 0000 0048   {
_note_to_freq:
; 0000 0049     float temp=START_NOTE;
; 0000 004A     unsigned int oct=(note & 0x00F0)>>4;
; 0000 004B     unsigned char i;
; 0000 004C 
; 0000 004D     if (oct>9) return (0);
	SBIW R28,4
	LDI  R30,LOW(229)
	ST   Y,R30
	LDI  R30,LOW(208)
	STD  Y+1,R30
	LDI  R30,LOW(130)
	STD  Y+2,R30
	LDI  R30,LOW(65)
	STD  Y+3,R30
	RCALL __SAVELOCR4
;	note -> Y+8
;	temp -> Y+4
;	oct -> R16,R17
;	i -> R19
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ANDI R30,LOW(0xF0)
	ANDI R31,HIGH(0xF0)
	RCALL __ASRW4
	MOVW R16,R30
	__CPWRN 16,17,10
	BRLO _0x21
	RCALL SUBOPT_0xA
	RJMP _0x2060003
; 0000 004E 
; 0000 004F     for (i=1; i<(12*oct + note_to_num(note)); i++)
_0x21:
	LDI  R19,LOW(1)
_0x23:
	__MULBNWRU 16,17,12
	PUSH R31
	PUSH R30
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _note_to_num
	RCALL SUBOPT_0x9
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	RCALL SUBOPT_0xB
	BRSH _0x24
; 0000 0050       {
; 0000 0051         temp*=SEMITONE;
	__GETD2S 4
	__GETD1N 0x3F879C7D
	RCALL __MULF12
	__PUTD1S 4
; 0000 0052       }
	SUBI R19,-1
	RJMP _0x23
_0x24:
; 0000 0053 
; 0000 0054     return ((unsigned int)temp);
	__GETD1S 4
	RCALL __CFD1U
_0x2060003:
	RCALL __LOADLOCR4
	ADIW R28,10
	RET
; 0000 0055   }
;
;
;//    
;unsigned int note_to_duration (int note)
; 0000 005A   {
_note_to_duration:
; 0000 005B     switch ( (note & 0x0F00) >>8 )
;	note -> Y+0
	RCALL SUBOPT_0x0
	ANDI R30,LOW(0xF00)
	ANDI R31,HIGH(0xF00)
	RCALL __ASRW8
; 0000 005C       {
; 0000 005D         case  0: return (NOTE_DURATION*8);    //32/4
	SBIW R30,0
	BRNE _0x28
	MOVW R30,R4
	RCALL __LSLW3
	RJMP _0x2060001
; 0000 005E         case  1: return (NOTE_DURATION*4);    //16/4
_0x28:
	RCALL SUBOPT_0x1
	BRNE _0x29
	MOVW R30,R4
	RCALL __LSLW2
	RJMP _0x2060001
; 0000 005F         case  2: return (NOTE_DURATION*2);    //8/4
_0x29:
	RCALL SUBOPT_0x2
	BRNE _0x2A
	MOVW R30,R4
	LSL  R30
	ROL  R31
	RJMP _0x2060001
; 0000 0060         case  3: return (NOTE_DURATION*1);    //4/4
_0x2A:
	RCALL SUBOPT_0x3
	BRNE _0x2B
	MOVW R30,R4
	RCALL SUBOPT_0x0
	RJMP _0x2060001
; 0000 0061         case  4: return (NOTE_DURATION/2);    //1/2
_0x2B:
	RCALL SUBOPT_0x4
	BRNE _0x2C
	MOVW R26,R4
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL __DIVW21
	RJMP _0x2060001
; 0000 0062         case  5: return (NOTE_DURATION/4);    //1/4
_0x2C:
	RCALL SUBOPT_0x5
	BRNE _0x2D
	MOVW R26,R4
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL __DIVW21
	RJMP _0x2060001
; 0000 0063         case  6: return (NOTE_DURATION/8);    //1/8
_0x2D:
	RCALL SUBOPT_0x6
	BRNE _0x2E
	MOVW R26,R4
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL __DIVW21
	RJMP _0x2060001
; 0000 0064         case  7: return (NOTE_DURATION/16);   //1/16
_0x2E:
	RCALL SUBOPT_0x7
	BRNE _0x2F
	MOVW R26,R4
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	RCALL __DIVW21
	RJMP _0x2060001
; 0000 0065         case  8: return (NOTE_DURATION/32);   //1/32
_0x2F:
	RCALL SUBOPT_0x8
	BRNE _0x30
	MOVW R26,R4
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	RCALL __DIVW21
	RJMP _0x2060001
; 0000 0066         case  9: return (NOTE_DURATION/64);   //1/64
_0x30:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x31
	MOVW R26,R4
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	RCALL __DIVW21
	RJMP _0x2060001
; 0000 0067         case 10: return (NOTE_DURATION/128);  //1/128
_0x31:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x33
	MOVW R26,R4
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	RCALL __DIVW21
	RJMP _0x2060001
; 0000 0068         default: return (0);
_0x33:
	RCALL SUBOPT_0xA
	RJMP _0x2060001
; 0000 0069       }
; 0000 006A   }
;
;
;//      
;unsigned char note_name(char c)
; 0000 006F   {
_note_name:
; 0000 0070     switch (c)
;	c -> Y+0
	LD   R30,Y
	RCALL SUBOPT_0x9
; 0000 0071       {
; 0000 0072         case 'P': return (0);
	CPI  R30,LOW(0x50)
	LDI  R26,HIGH(0x50)
	CPC  R31,R26
	BRNE _0x37
	LDI  R30,LOW(0)
	RJMP _0x2060002
; 0000 0073         case 'C': return (1);
_0x37:
	CPI  R30,LOW(0x43)
	LDI  R26,HIGH(0x43)
	CPC  R31,R26
	BRNE _0x38
	LDI  R30,LOW(1)
	RJMP _0x2060002
; 0000 0074         case 'D': return (2);
_0x38:
	CPI  R30,LOW(0x44)
	LDI  R26,HIGH(0x44)
	CPC  R31,R26
	BRNE _0x39
	LDI  R30,LOW(2)
	RJMP _0x2060002
; 0000 0075         case 'E': return (3);
_0x39:
	CPI  R30,LOW(0x45)
	LDI  R26,HIGH(0x45)
	CPC  R31,R26
	BRNE _0x3A
	LDI  R30,LOW(3)
	RJMP _0x2060002
; 0000 0076         case 'F': return (4);
_0x3A:
	CPI  R30,LOW(0x46)
	LDI  R26,HIGH(0x46)
	CPC  R31,R26
	BRNE _0x3B
	LDI  R30,LOW(4)
	RJMP _0x2060002
; 0000 0077         case 'G': return (5);
_0x3B:
	CPI  R30,LOW(0x47)
	LDI  R26,HIGH(0x47)
	CPC  R31,R26
	BRNE _0x3C
	LDI  R30,LOW(5)
	RJMP _0x2060002
; 0000 0078         case 'A': return (6);
_0x3C:
	CPI  R30,LOW(0x41)
	LDI  R26,HIGH(0x41)
	CPC  R31,R26
	BRNE _0x3D
	LDI  R30,LOW(6)
	RJMP _0x2060002
; 0000 0079         case 'H': return (7);
_0x3D:
	CPI  R30,LOW(0x48)
	LDI  R26,HIGH(0x48)
	CPC  R31,R26
	BRNE _0x3F
	LDI  R30,LOW(7)
	RJMP _0x2060002
; 0000 007A         default : return (8);
_0x3F:
	LDI  R30,LOW(8)
; 0000 007B       }
; 0000 007C   }
_0x2060002:
	ADIW R28,1
	RET
;
;//     
;void sound (int note)
; 0000 0080   {
_sound:
; 0000 0081     if (!note_to_num(note))                    // 
;	note -> Y+0
	RCALL SUBOPT_0xC
	RCALL _note_to_num
	CPI  R30,0
	BRNE _0x40
; 0000 0082       {
; 0000 0083         delay_ms(note_to_duration(note));
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
; 0000 0084         return;
	RJMP _0x2060001
; 0000 0085       }
; 0000 0086 
; 0000 0087     OCR1A=CLK_FREQ/2/PR/note_to_freq(note)-1;
_0x40:
	LDS  R26,_freq
	LDS  R27,_freq+1
	LDS  R24,_freq+2
	LDS  R25,_freq+3
	__GETD1N 0x2
	RCALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xC
	RCALL _note_to_freq
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CLR  R22
	CLR  R23
	RCALL __DIVD21
	__SUBD1N 1
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 0088 
; 0000 0089     TCCR1A=0x40;
	LDI  R30,LOW(64)
	OUT  0x2F,R30
; 0000 008A     delay_ms(note_to_duration(note));
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
; 0000 008B     TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 008C   }
_0x2060001:
	ADIW R28,2
	RET
;
;
;// 
;int read_mel(char *mel)
; 0000 0091   {
_read_mel:
; 0000 0092     int note=0;               // 
; 0000 0093     char i, num, denum;
; 0000 0094 
; 0000 0095     for (i=0; i<strlen(mel); i++)
	RCALL __SAVELOCR6
;	*mel -> Y+6
;	note -> R16,R17
;	i -> R19
;	num -> R18
;	denum -> R21
	__GETWRN 16,17,0
	LDI  R19,LOW(0)
_0x42:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL SUBOPT_0xE
	RCALL _strlen
	RCALL SUBOPT_0xB
	BRLO PC+2
	RJMP _0x43
; 0000 0096       {
; 0000 0097         if (isalpha(mel[i]))            // 
	RCALL SUBOPT_0xF
	RCALL _isalpha
	CPI  R30,0
	BRNE PC+2
	RJMP _0x44
; 0000 0098           {
; 0000 0099             note=note_name(mel[i]);     // 
	RCALL SUBOPT_0xF
	RCALL _note_name
	MOV  R16,R30
	CLR  R17
; 0000 009A 
; 0000 009B             if (mel[i]-'P')           //  ,   
	RCALL SUBOPT_0x10
	SUBI R30,LOW(80)
	SBCI R31,HIGH(80)
	BREQ _0x45
; 0000 009C                 {
; 0000 009D                   i++;
	SUBI R19,-1
; 0000 009E 
; 0000 009F                   if (isalpha(mel[i]))    //   #
	RCALL SUBOPT_0xF
	RCALL _isalpha
	CPI  R30,0
	BREQ _0x46
; 0000 00A0                     {
; 0000 00A1                       note+=1*8;
	__ADDWRN 16,17,8
; 0000 00A2                       i+=2;
	SUBI R19,-LOW(2)
; 0000 00A3                     }
; 0000 00A4 
; 0000 00A5                     note+=(mel[i]-'0'+OCTAVE_OFFSET)*16; //   7-4 
_0x46:
	RCALL SUBOPT_0x10
	SBIW R30,48
	ADIW R30,3
	RCALL __LSLW4
	__ADDWRR 16,17,30,31
; 0000 00A6                     i+=2;                                //   
; 0000 00A7                 }
; 0000 00A8 
; 0000 00A9               else                                       // 
_0x45:
; 0000 00AA                 {
; 0000 00AB                   i+=2;                                  //     
_0x81:
	SUBI R19,-LOW(2)
; 0000 00AC                 }
; 0000 00AD 
; 0000 00AE             num=(mel[i]-'0');
	RCALL SUBOPT_0x10
	SBIW R30,48
	MOV  R18,R30
; 0000 00AF             i+=2;
	SUBI R19,-LOW(2)
; 0000 00B0             denum=(mel[i]-'0');
	RCALL SUBOPT_0x10
	SBIW R30,48
	MOV  R21,R30
; 0000 00B1             i++;
	SUBI R19,-1
; 0000 00B2 
; 0000 00B3             if (isdigit(mel[i]))         // 
	RCALL SUBOPT_0xF
	RCALL _isdigit
	CPI  R30,0
	BREQ _0x48
; 0000 00B4               {
; 0000 00B5                 denum=denum*10+(mel[i]-'0');
	LDI  R26,LOW(10)
	MULS R21,R26
	RCALL SUBOPT_0x10
	SBIW R30,48
	ADD  R30,R0
	MOV  R21,R30
; 0000 00B6                 i++;
	SUBI R19,-1
; 0000 00B7 
; 0000 00B8                 if (isdigit(mel[i]))
	RCALL SUBOPT_0xF
	RCALL _isdigit
	CPI  R30,0
	BREQ _0x49
; 0000 00B9                   denum=denum*10+(mel[i]-'0');
	LDI  R26,LOW(10)
	MULS R21,R26
	RCALL SUBOPT_0x10
	SBIW R30,48
	ADD  R30,R0
	MOV  R21,R30
; 0000 00BA               }
_0x49:
; 0000 00BB 
; 0000 00BC             if (num==1)              //   
_0x48:
	CPI  R18,1
	BRNE _0x4A
; 0000 00BD                 {
; 0000 00BE                   switch(denum)        //
	MOV  R30,R21
	RCALL SUBOPT_0x9
; 0000 00BF                     {
; 0000 00C0                       case   1: note+= 3*256; break;
	RCALL SUBOPT_0x1
	BRNE _0x4E
	__ADDWRN 16,17,768
	RJMP _0x4D
; 0000 00C1                       case   2: note+= 4*256; break;
_0x4E:
	RCALL SUBOPT_0x2
	BRNE _0x4F
	__ADDWRN 16,17,1024
	RJMP _0x4D
; 0000 00C2                       case   4: note+= 5*256; break;
_0x4F:
	RCALL SUBOPT_0x4
	BRNE _0x50
	__ADDWRN 16,17,1280
	RJMP _0x4D
; 0000 00C3                       case   8: note+= 6*256; break;
_0x50:
	RCALL SUBOPT_0x8
	BRNE _0x51
	__ADDWRN 16,17,1536
	RJMP _0x4D
; 0000 00C4                       case  16: note+= 7*256; break;
_0x51:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x52
	__ADDWRN 16,17,1792
	RJMP _0x4D
; 0000 00C5                       case  32: note+= 8*256; break;
_0x52:
	CPI  R30,LOW(0x20)
	LDI  R26,HIGH(0x20)
	CPC  R31,R26
	BRNE _0x53
	__ADDWRN 16,17,2048
	RJMP _0x4D
; 0000 00C6                       case  64: note+= 9*256; break;
_0x53:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x54
	__ADDWRN 16,17,2304
	RJMP _0x4D
; 0000 00C7                       case 128: note+=10*256; break;
_0x54:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x4D
	__ADDWRN 16,17,2560
; 0000 00C8                     }
_0x4D:
; 0000 00C9                 }
; 0000 00CA               else                       //  
	RJMP _0x56
_0x4A:
; 0000 00CB                 {
; 0000 00CC                   switch (num)
	MOV  R30,R18
	RCALL SUBOPT_0x9
; 0000 00CD                     {
; 0000 00CE                       case 8: note+=0*256;
	RCALL SUBOPT_0x8
	BRNE _0x5A
	__ADDWRN 16,17,0
; 0000 00CF                       case 4: note+=1*256;
	RJMP _0x5B
_0x5A:
	RCALL SUBOPT_0x4
	BRNE _0x5C
_0x5B:
	__ADDWRN 16,17,256
; 0000 00D0                       case 2: note+=2*256;
	RJMP _0x5D
_0x5C:
	RCALL SUBOPT_0x2
	BRNE _0x59
_0x5D:
	__ADDWRN 16,17,512
; 0000 00D1                     }
_0x59:
; 0000 00D2                 }
_0x56:
; 0000 00D3 
; 0000 00D4 
; 0000 00D5             sound(note);   //  
	ST   -Y,R17
	ST   -Y,R16
	RCALL _sound
; 0000 00D6           }
; 0000 00D7       }
_0x44:
	SUBI R19,-1
	RJMP _0x42
_0x43:
; 0000 00D8 
; 0000 00D9     return (1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL __LOADLOCR6
	ADIW R28,8
	RET
; 0000 00DA   }
;void main(void)
; 0000 00DC {
_main:
; 0000 00DD 
; 0000 00DE PORTB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x18,R30
; 0000 00DF DDRB=0x02;
	LDI  R30,LOW(2)
	OUT  0x17,R30
; 0000 00E0 
; 0000 00E1 PORTC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x15,R30
; 0000 00E2 DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
; 0000 00E3 
; 0000 00E4 PORTD=0x00;
	OUT  0x12,R30
; 0000 00E5 DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
; 0000 00E6 
; 0000 00E7 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00E8 
; 0000 00E9 TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 00EA TCCR1B=0x09;   //CTC +  1
	LDI  R30,LOW(9)
	OUT  0x2E,R30
; 0000 00EB 
; 0000 00EC //UCSRA=0x00;             // 
; 0000 00ED UCSRA=0x02;   //Double USART transmission speed
	LDI  R30,LOW(2)
	OUT  0xB,R30
; 0000 00EE //UCSRB=0x08;             //Transmitter Enable
; 0000 00EF //UCSRB=0x10;   //Receiver Enable
; 0000 00F0 //UCSRB=0x12;   //Transmitter and Receiver Enable
; 0000 00F1 UCSRC=0x86;             //8-bit Character
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 00F2 
; 0000 00F3 UBRRH = (unsigned char)(MYUBRR>>8);   //   
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 00F4 UBRRL = (unsigned char)(MYUBRR);      //   
	LDI  R30,LOW(25)
	OUT  0x9,R30
; 0000 00F5 track=1;
	RCALL SUBOPT_0x11
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL __EEPROMWRW
; 0000 00F6 freq=4000000;
	RCALL SUBOPT_0x12
	STS  _freq,R30
	STS  _freq+1,R31
	STS  _freq+2,R22
	STS  _freq+3,R23
; 0000 00F7 //registor=0;
; 0000 00F8 
; 0000 00F9 while (1)
_0x5F:
; 0000 00FA {
; 0000 00FB Dig_init(registor);
	RCALL SUBOPT_0x13
	RCALL __EEPROMRDW
	RCALL SUBOPT_0xE
	RCALL _Dig_init
; 0000 00FC 
; 0000 00FD  if(PINC.1==0) // , PC1,   
	SBIC 0x13,1
	RJMP _0x62
; 0000 00FE   {
; 0000 00FF   if(track>=5) {track=0;}
	RCALL SUBOPT_0x14
	SBIW R30,5
	BRLT _0x63
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0xA
	RCALL __EEPROMWRW
; 0000 0100   track=track+1;
_0x63:
	RCALL SUBOPT_0x14
	ADIW R30,1
	RCALL SUBOPT_0x11
	RCALL __EEPROMWRW
; 0000 0101   Dig_init(track);
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0xE
	RCALL _Dig_init
; 0000 0102   delay_ms(300);
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	RCALL SUBOPT_0x15
; 0000 0103   }
; 0000 0104  if(PINC.2==0) // , PC2,  
_0x62:
	SBIC 0x13,2
	RJMP _0x64
; 0000 0105  {
; 0000 0106  if(fr>=8) {fr=0;}
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CP   R6,R30
	CPC  R7,R31
	BRLT _0x65
	CLR  R6
	CLR  R7
; 0000 0107  fr=fr+1;
_0x65:
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
; 0000 0108   switch(fr)
	MOVW R30,R6
; 0000 0109   {
; 0000 010A   case 0:{freq=900000; Dig_init(fr);  delay_ms(200); break;}
	SBIW R30,0
	BRNE _0x69
	__GETD1N 0xDBBA0
	RJMP _0x82
; 0000 010B   case 1:{freq=1000000; Dig_init(fr);  delay_ms(200); break;}
_0x69:
	RCALL SUBOPT_0x1
	BRNE _0x6A
	__GETD1N 0xF4240
	RJMP _0x82
; 0000 010C   case 2:{freq=2000000; Dig_init(fr);  delay_ms(200); break;}
_0x6A:
	RCALL SUBOPT_0x2
	BRNE _0x6B
	__GETD1N 0x1E8480
	RJMP _0x82
; 0000 010D   case 3:{freq=3000000; Dig_init(fr);  delay_ms(200); break;}
_0x6B:
	RCALL SUBOPT_0x3
	BRNE _0x6C
	__GETD1N 0x2DC6C0
	RJMP _0x82
; 0000 010E   case 4:{freq=4000000; Dig_init(fr);  delay_ms(200); break;}
_0x6C:
	RCALL SUBOPT_0x4
	BRNE _0x6D
	RCALL SUBOPT_0x12
	RJMP _0x82
; 0000 010F   case 5:{freq=5000000; Dig_init(fr);  delay_ms(200); break;}
_0x6D:
	RCALL SUBOPT_0x5
	BRNE _0x6E
	__GETD1N 0x4C4B40
	RJMP _0x82
; 0000 0110   case 6:{freq=6000000; Dig_init(fr);  delay_ms(200); break;}
_0x6E:
	RCALL SUBOPT_0x6
	BRNE _0x6F
	__GETD1N 0x5B8D80
	RJMP _0x82
; 0000 0111   case 7:{freq=7000000; Dig_init(fr);  delay_ms(200); break;}
_0x6F:
	RCALL SUBOPT_0x7
	BRNE _0x70
	__GETD1N 0x6ACFC0
	RJMP _0x82
; 0000 0112   case 8:{freq=8000000; Dig_init(fr);  delay_ms(200); break;}
_0x70:
	RCALL SUBOPT_0x8
	BRNE _0x68
	__GETD1N 0x7A1200
_0x82:
	STS  _freq,R30
	STS  _freq+1,R31
	STS  _freq+2,R22
	STS  _freq+3,R23
	ST   -Y,R7
	ST   -Y,R6
	RCALL _Dig_init
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RCALL SUBOPT_0x15
; 0000 0113   }
_0x68:
; 0000 0114  }
; 0000 0115 
; 0000 0116  if(PINC.5==0) //  
_0x64:
	SBIC 0x13,5
	RJMP _0x72
; 0000 0117  {
; 0000 0118  registor=0;
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0xA
	RCALL __EEPROMWRW
; 0000 0119  }
; 0000 011A 
; 0000 011B if(PINC.0==0) // , PC0
_0x72:
	SBIC 0x13,0
	RJMP _0x73
; 0000 011C {
; 0000 011D     registor=registor+1;
	RCALL SUBOPT_0x13
	RCALL __EEPROMRDW
	ADIW R30,1
	RCALL SUBOPT_0x13
	RCALL __EEPROMWRW
; 0000 011E 	if(track==1) { duration=500; read_mel(mel1); read_mel(mel2);} else
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x1
	BRNE _0x74
	RCALL SUBOPT_0x16
	RJMP _0x83
_0x74:
; 0000 011F     if(track==2) { duration=700; read_mel(mel3); } else
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x2
	BREQ _0x84
; 0000 0120     if(track==3)
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x3
	BRNE _0x78
; 0000 0121     { duration=500;
	RCALL SUBOPT_0x16
; 0000 0122       read_mel(mel1); read_mel(mel2);
	RCALL SUBOPT_0x17
; 0000 0123       delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x15
; 0000 0124       read_mel(mel1); read_mel(mel2);
	LDI  R30,LOW(_mel1)
	LDI  R31,HIGH(_mel1)
	RCALL SUBOPT_0x17
	LDI  R30,LOW(_mel2)
	LDI  R31,HIGH(_mel2)
	RJMP _0x83
; 0000 0125     } else
_0x78:
; 0000 0126     if(track==4)
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x4
	BRNE _0x7A
; 0000 0127     {
; 0000 0128       duration=700;
	LDI  R30,LOW(700)
	LDI  R31,HIGH(700)
	MOVW R4,R30
; 0000 0129       read_mel(mel3);
	LDI  R30,LOW(_mel3)
	LDI  R31,HIGH(_mel3)
	RCALL SUBOPT_0x17
; 0000 012A       delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x15
; 0000 012B       read_mel(mel3);
	RJMP _0x85
; 0000 012C     } else
_0x7A:
; 0000 012D     if(track==5)
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x5
	BRNE _0x7C
; 0000 012E     {
; 0000 012F       duration=500;
	RCALL SUBOPT_0x16
; 0000 0130       read_mel(mel1); read_mel(mel2);
	RCALL SUBOPT_0x17
; 0000 0131       delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL SUBOPT_0x15
; 0000 0132       duration=700;
_0x84:
	LDI  R30,LOW(700)
	LDI  R31,HIGH(700)
	MOVW R4,R30
; 0000 0133       read_mel(mel3);
_0x85:
	LDI  R30,LOW(_mel3)
	LDI  R31,HIGH(_mel3)
_0x83:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _read_mel
; 0000 0134     }
; 0000 0135     delay_ms(100);
_0x7C:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x15
; 0000 0136 }
; 0000 0137 if(registor>=10) { registor=0; } else {}
_0x73:
	RCALL SUBOPT_0x13
	RCALL __EEPROMRDW
	SBIW R30,10
	BRLT _0x7D
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0xA
	RCALL __EEPROMWRW
_0x7D:
; 0000 0138 }
	RJMP _0x5F
; 0000 0139 	};
_0x7F:
	RJMP _0x7F

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret

	.CSEG
_isalpha:
    ldi  r30,1
    ld   r31,y+
    cpi  r31,'A'
    brlo isalpha0
    cpi  r31,'Z'+1
    brlo isalpha1
    cpi  r31,'a'
    brlo isalpha0
    cpi  r31,'z'+1
    brlo isalpha1
isalpha0:
    clr  r30
isalpha1:
    ret
_isdigit:
    ldi  r30,1
    ld   r31,y+
    cpi  r31,'0'
    brlo isdigit0
    cpi  r31,'9'+1
    brlo isdigit1
isdigit0:
    clr  r30
isdigit1:
    ret
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.DSEG
_freq:
	.BYTE 0x4

	.ESEG
_registor:
	.BYTE 0x2
_track:
	.BYTE 0x2

	.DSEG
_mel1:
	.BYTE 0xD3
_mel2:
	.BYTE 0x9C
_mel3:
	.BYTE 0xD1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x0:
	LD   R30,Y
	LDD  R31,Y+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x2:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x4:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x5:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x6:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x7:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x8:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x9:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB:
	MOV  R26,R19
	LDI  R27,0
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xC:
	RCALL SUBOPT_0x0
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	RCALL _note_to_duration
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xE:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xF:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	LD   R30,X
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x10:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	LD   R30,X
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x11:
	LDI  R26,LOW(_track)
	LDI  R27,HIGH(_track)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	__GETD1N 0x3D0900
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x13:
	LDI  R26,LOW(_registor)
	LDI  R27,HIGH(_registor)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x14:
	RCALL SUBOPT_0x11
	RCALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x15:
	RCALL SUBOPT_0xE
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	MOVW R4,R30
	LDI  R30,LOW(_mel1)
	LDI  R31,HIGH(_mel1)
	RCALL SUBOPT_0xE
	RCALL _read_mel
	LDI  R30,LOW(_mel2)
	LDI  R31,HIGH(_mel2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	RCALL SUBOPT_0xE
	RJMP _read_mel


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__ASRW8:
	MOV  R30,R31
	CLR  R31
	SBRC R30,7
	SER  R31
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
